/**
 *
 * *** Copyright Notice ***
 *
 * BeStMan Copyright (c) 2010, The Regents of the University of California, 
 * through Lawrence Berkeley National Laboratory (subject to receipt of any 
 * required approvals from the U.S. Dept. of Energy).  This software was 
 * developed under funding from the U.S. Department of Energy and is 
 * associated with the Berkeley Lab Scientific Data Management Group projects.
 * All rights reserved.
 * 
 * If you have questions about your rights to use or distribute this software, 
 * please contact Berkeley Lab's Technology Transfer Department at TTD@lbl.gov.
 * 
 * NOTICE.  This software was developed under funding from the 
 * U.S. Department of Energy.  As such, the U.S. Government has been granted 
 * for itself and others acting on its behalf a paid-up, nonexclusive, 
 * irrevocable, worldwide license in the Software to reproduce, prepare 
 * derivative works, and perform publicly and display publicly.  
 * Beginning five (5) years after the date permission to assert copyright is 
 * obtained from the U.S. Department of Energy, and subject to any subsequent 
 * five (5) year renewals, the U.S. Government is granted for itself and others
 * acting on its behalf a paid-up, nonexclusive, irrevocable, worldwide license
 * in the Software to reproduce, prepare derivative works, distribute copies to
 * the public, perform publicly and display publicly, and to permit others to
 * do so.
 *
*/
/**
 *
 * Email questions to SRM@LBL.GOV
 * Scientific Data Management Research Group
 * Lawrence Berkeley National Laboratory
 * http://sdm.lbl.gov/bestman
 *
*/

package gov.lbl.srm.client.wsdl;
 
import java.util.*;
import gov.lbl.srm.StorageResourceManager.*;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//FileStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public class FileStatus {

private org.apache.axis.types.URI SURL;
private org.apache.axis.types.URI transferURL;
private org.apache.axis.types.URI TURL;
private TReturnStatus returnStatus; 
private SrmRequestReturnStatus srmRequestReturnStatus; 
private org.apache.axis.types.UnsignedLong fileSize; 
private Integer estimatedWaitTime;
private Integer remainingPinLifeTime;
private Integer remainingFileLifeTime;
private Integer fileLifeTime;
private Integer pinLifeTime;
private ArrayOfTExtraInfo protocolInfo;

 
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// constructor
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public FileStatus () {
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setStatus(TReturnStatus rStatus) {
  if(returnStatus == null) {
    returnStatus = rStatus;
    return;
  }

  if(rStatus != null) {
    if(rStatus.getStatusCode() != null) {
      returnStatus.setStatusCode(rStatus.getStatusCode());
    }
    if(rStatus.getExplanation() != null) {
      returnStatus.setExplanation(rStatus.getExplanation());
    }
  }
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TReturnStatus getStatus() {
  return returnStatus; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setFileLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setFileLifeTime(Integer fileLifeTime) {
  this.fileLifeTime = fileLifeTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getFileLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getFileLifeTime() {
  return fileLifeTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setPinLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setPinLifeTime(Integer pinLifeTime) {
  this.pinLifeTime = pinLifeTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getPinLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getPinLifeTime() {
  return pinLifeTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setSrmRequestReturnStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setSrmRequestReturnStatus(SrmRequestReturnStatus rStatus) {
  srmRequestReturnStatus = rStatus;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getSrmRequestReturnStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public SrmRequestReturnStatus getSrmRequestReturnStatus() {
  return srmRequestReturnStatus;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setSURL
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setSURL(org.apache.axis.types.URI surl) {
   this.SURL = surl; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getSURL
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public org.apache.axis.types.URI getSURL() {
   return SURL;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setTURL
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setTURL(org.apache.axis.types.URI turl) {
   this.TURL = turl; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getTURL
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public org.apache.axis.types.URI getTURL() {
   return TURL;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setTransferSURL
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setTransferSURL(org.apache.axis.types.URI transferUrl) {
   this.transferURL = transferUrl;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getTransferSURL
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public org.apache.axis.types.URI getTransferSURL() {
   return transferURL;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setRemainingPinLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setRemainingPinLifeTime(Integer remainingPinLifeTime) {
   this.remainingPinLifeTime = remainingPinLifeTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getRemainingPinLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getRemainingPinLifeTime() {
   return this.remainingPinLifeTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setRemainingFileLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setRemainingFileLifeTime(Integer remainingFileLifeTime) {
   this.remainingFileLifeTime = remainingFileLifeTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getRemainingFileLifeTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getRemainingFileLifeTime() {
   return this.remainingFileLifeTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setEstimatedWaitTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setEstimatedWaitTime(Integer estimatedWaitTime) {
   this.estimatedWaitTime = estimatedWaitTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getEstimatedWaitTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getEstimatedWaitTime() {
   return this.estimatedWaitTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setFileSize
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setFileSize(org.apache.axis.types.UnsignedLong fileSize) {
   this.fileSize = fileSize;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getFileSize
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public org.apache.axis.types.UnsignedLong getFileSize() {
   return this.fileSize; 
}

public void setTransferProtocolInfo(ArrayOfTExtraInfo protocolInfo) {
  this.protocolInfo = protocolInfo;
}

public ArrayOfTExtraInfo getTransferProtocolInfo() {
  return protocolInfo;
}

}
