/**
 *
 * *** Copyright Notice ***
 *
 * BeStMan Copyright (c) 2010, The Regents of the University of California, 
 * through Lawrence Berkeley National Laboratory (subject to receipt of any 
 * required approvals from the U.S. Dept. of Energy).  This software was 
 * developed under funding from the U.S. Department of Energy and is 
 * associated with the Berkeley Lab Scientific Data Management Group projects.
 * All rights reserved.
 * 
 * If you have questions about your rights to use or distribute this software, 
 * please contact Berkeley Lab's Technology Transfer Department at TTD@lbl.gov.
 * 
 * NOTICE.  This software was developed under funding from the 
 * U.S. Department of Energy.  As such, the U.S. Government has been granted 
 * for itself and others acting on its behalf a paid-up, nonexclusive, 
 * irrevocable, worldwide license in the Software to reproduce, prepare 
 * derivative works, and perform publicly and display publicly.  
 * Beginning five (5) years after the date permission to assert copyright is 
 * obtained from the U.S. Department of Energy, and subject to any subsequent 
 * five (5) year renewals, the U.S. Government is granted for itself and others
 * acting on its behalf a paid-up, nonexclusive, irrevocable, worldwide license
 * in the Software to reproduce, prepare derivative works, distribute copies to
 * the public, perform publicly and display publicly, and to permit others to
 * do so.
 *
*/
/**
 *
 * Email questions to SRM@LBL.GOV
 * Scientific Data Management Research Group
 * Lawrence Berkeley National Laboratory
 * http://sdm.lbl.gov/bestman
 *
*/

package gov.lbl.srm.client.wsdl;
 
import java.util.*;
import gov.lbl.srm.StorageResourceManager.*;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//SRMRequestStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public class SRMRequestStatus {

private Date timeStamp;
private TReturnStatus returnStatus; 
private String requestToken;
private Integer remainingRequestTime;
private Integer remainingDeferredStartTime;
private HashMap map =new HashMap();
private HashMap pathDetails =new HashMap();

 
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// constructor
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void SRMRequestStatus() {
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setTimeStamp
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setTimeStamp(Date date) {
   timeStamp = date;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getTimeStamp
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Date getTimeStamp() {
   return timeStamp;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setReturnStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setReturnStatus(TReturnStatus rStatus) {
   if(returnStatus == null) {
     returnStatus = rStatus;
     return;
   }
   if(returnStatus != null) {
    if(rStatus.getStatusCode() != null) {
      returnStatus.setStatusCode(rStatus.getStatusCode());
    }
    if(rStatus.getExplanation() != null) {
      returnStatus.setExplanation(rStatus.getExplanation());
    }
  }
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getReturnStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public TReturnStatus getReturnStatus() {
  return returnStatus; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setRequestToken
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setRequestToken(String rToken) {
   requestToken = rToken;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getRequestToken
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public String getRequestToken() {
   return requestToken;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setRemainingTotalRequestTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setRemainingTotalRequestTime(Integer remainingRequestTime) {
   this.remainingRequestTime = remainingRequestTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getRemainingTotalRequestTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getRemainingTotalRequestTime() {
   return this.remainingRequestTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setRemainingDeferredStartTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setRemainingDeferredStartTime(Integer remainingDeferredStartTime) {
   this.remainingDeferredStartTime = remainingDeferredStartTime;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getRemainingDeferredStartTime
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public Integer getRemainingDeferredStartTime() {
   return this.remainingDeferredStartTime; 
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setPathDetails
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setPathDetails(HashMap pathDetails) {
  this.pathDetails = pathDetails;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getPathDetails
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

/*  @return HashMap contains surl has the key and object has PathDetail
 *  @see PathDetail
 *
*/

public HashMap getPathDetails() {
   return pathDetails;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// setFileStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

public void setFileStatuses(HashMap map) {
  this.map = map;
}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// getFileStatus
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

/** Client makes a status of previously submitted request on files
 *  that a user selected, and the status of files get returned.
 *  getFileStatuses is called by SRMRequest.getStatus()
 *  @return HashMap contains surl has the key and object has FileStatus
 *  @see FileStatus
 *
**/


public HashMap getFileStatuses() {
  return map; 
}
}
